<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [bullmq](./bullmq.md) &gt; [FlowProducer](./bullmq.flowproducer.md)

## FlowProducer class

This class allows to add jobs with dependencies between them in such a way that it is possible to build complex flows. Note: A flow is a tree-like structure of jobs that depend on each other. Whenever the children of a given parent are completed, the parent will be processed, being able to access the children's result data. All Jobs can be in different queues, either children or parents,

<b>Signature:</b>

```typescript
export declare class FlowProducer extends EventEmitter 
```
<b>Extends:</b> EventEmitter

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(opts)](./bullmq.flowproducer._constructor_.md) |  | Constructs a new instance of the <code>FlowProducer</code> class |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [client](./bullmq.flowproducer.client.md) |  | Promise&lt;[RedisClient](./bullmq.redisclient.md)<!-- -->&gt; |  |
|  [closing](./bullmq.flowproducer.closing.md) |  | Promise&lt;void&gt; |  |
|  [connection](./bullmq.flowproducer.connection.md) |  | [RedisConnection](./bullmq.redisconnection.md) |  |
|  [keys](./bullmq.flowproducer.keys.md) |  | [KeysMap](./bullmq.keysmap.md) |  |
|  [opts](./bullmq.flowproducer.opts.md) |  | [QueueBaseOptions](./bullmq.queuebaseoptions.md) |  |
|  [queueKeys](./bullmq.flowproducer.queuekeys.md) |  | [QueueKeys](./bullmq.queuekeys.md) |  |
|  [toKey](./bullmq.flowproducer.tokey.md) |  | (name: string, type: string) =&gt; string |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [add(flow, opts)](./bullmq.flowproducer.add.md) |  | Adds a flow.<!-- -->This call would be atomic, either it fails and no jobs will be added to the queues, or it succeeds and all jobs will be added. |
|  [addBulk(flows)](./bullmq.flowproducer.addbulk.md) |  | Adds multiple flows.<!-- -->A flow is a tree-like structure of jobs that depend on each other. Whenever the children of a given parent are completed, the parent will be processed, being able to access the children's result data.<!-- -->All Jobs can be in different queues, either children or parents, however this call would be atomic, either it fails and no jobs will be added to the queues, or it succeeds and all jobs will be added. |
|  [close()](./bullmq.flowproducer.close.md) |  |  |
|  [disconnect()](./bullmq.flowproducer.disconnect.md) |  |  |
|  [getFlow(opts)](./bullmq.flowproducer.getflow.md) |  | Get a flow. |

